/// <reference types="./raw-node.d.ts" />
import { freeze } from '../util/object-utils.js';
/**
 * @internal
 */
export const RawNode = freeze({
    is(node) {
        return node.kind === 'RawNode';
    },
    create(sqlFragments, params) {
        return freeze({
            kind: 'RawNode',
            sqlFragments: freeze(sqlFragments),
            params: freeze(params),
        });
    },
    createWithSql(sql) {
        return RawNode.create([sql], []);
    },
});
