import * as route53 from "aws-cdk-lib/aws-route53";
import * as appsync from "@aws-cdk/aws-appsync-alpha";
import * as acm from "aws-cdk-lib/aws-certificatemanager";
import { AppSyncApi } from "../AppSyncApi";
export interface CustomDomainProps {
    /**
     * The domain to be assigned to the API endpoint (ie. api.domain.com)
     */
    domainName?: string;
    /**
     * The hosted zone in Route 53 that contains the domain. By default, SST will look for a hosted zone by stripping out the first part of the domainName that's passed in. So, if your domainName is api.domain.com. SST will default the hostedZone to domain.com.
     */
    hostedZone?: string;
    /**
     * Set this option if the domain is not hosted on Amazon Route 53.
     */
    isExternalDomain?: boolean;
    cdk?: {
        /**
         * Override the internally created hosted zone
         */
        hostedZone?: route53.IHostedZone;
        /**
         * Override the internally created certificate
         */
        certificate?: acm.ICertificate;
    };
}
export declare function buildCustomDomainData(scope: AppSyncApi, customDomain: string | CustomDomainProps | undefined): appsync.DomainOptions | undefined;
